unit KGF_Edge_Main;

interface

uses
  WinApi.Windows, WinApi.Messages, System.SysUtils, System.Variants, System.Classes, Vcl.Graphics,
  Vcl.Controls, Vcl.Forms, Vcl.Dialogs, Vcl.StdCtrls, System.IOUtils, Winapi.WebView2,
  Winapi.ActiveX, Vcl.Edge, Vcl.OleCtrls, SHDocVw, Vcl.ExtCtrls;

type TKgfEdge = class                          // ma classe drive
  private
    fPanel: TPanel;                            // conteneur visuel
    fEdge: TEdgeBrowser;                       // pour y enregistrer l'objet TEdgerowser cr par me constructeur de TKgfEdge
    fReady: boolean;                           // flag positionn par l'vnement OnNavigationVomplete
    fIsSuccess: Boolean;                       // copie de la proprit IsSuccess de fEdge
    fWebErrorStatus: COREWEBVIEW2_WEB_ERROR_STATUS;  // idem
  published
    constructor CreateNew(hDest: HWND);
    destructor Destroy; override;
    procedure NavigationCompleted(Sender: TCustomEdgeBrowser;
      aIsSuccess: Boolean; aWebErrorStatus: COREWEBVIEW2_WEB_ERROR_STATUS);
  property Panel: TPanel read fPanel write fPanel;
  property Edge: TEdgeBrowser read fEdge write fEdge;
  property Ready: boolean read fReady write fReady;
  property IsSuccess: boolean read fIsSuccess write fReady;
  property WebErrorStatus: COREWEBVIEW2_WEB_ERROR_STATUS read fWebErrorStatus write fWebErrorStatus;

  end;

var
  DummyForm: TForm;



implementation

constructor TKgfEdge.CreateNew(hDest: HWND);
begin
  inherited;
showmessage('CreateNew - start');
  Panel := TPanel.Create(DummyForm);
  Panel.ParentWindow := hDest;
showmessage('CreateNew - 0');
  Edge := TEdgeBrowser.Create(Panel);
showmessage('CreateNew - 1');
  fReady := true;
showmessage('CreateNew - 2');
  Edge.ParentWindow := Panel.Handle;
showmessage('CreateNew - 3');
  Edge.Top := 0;
  Edge.Left := 0;
  Edge.Width := Panel.ClientWidth;
  Edge.Height := Panel.ClientHeight;
showmessage('CreateNew - 4');
  Edge.OnNavigationCompleted := NavigationCompleted;
showmessage('CreateNew - fin');
end;

destructor TKgfEdge.Destroy;
begin
  if assigned(Edge) then Edge.free;
  inherited;
end;

procedure TKgfEdge.NavigationCompleted(Sender: TCustomEdgeBrowser;
      aIsSuccess: Boolean; aWebErrorStatus: COREWEBVIEW2_WEB_ERROR_STATUS);
begin
  IsSuccess := aIsSuccess;
  WebErrorStatus := aWebErrorStatus;
  fReady := true;
end;


{
  **********************************************
  *            interface Panoramic             *
  **********************************************
}

function Create_KGF_EDGE(hDest: HWND): TKgfEdge; stdcall; export;
var
  KEB: TKgfEdge;
  BDSRepo :array[0..MAX_PATH -1] of char;
  Path: string;

begin
      result := nil;
      try
        ExpandEnvironmentStrings('%BDSCatalogRepository%\EdgeView2SDK-1.0.2739.1\Bin\x86',
          BDSRepo, MAX_PATH);
        Path := GetEnvironmentVariable('PATH') +';' +BDSRepo;
        SetEnvironmentVariable('PATH', PChar(Path));
//showmessage('Create_KGF_EDGE - start  Path='+#13#10+Path);
showmessage('Create_KGF_EDGE - start');
        KEB := TKgfEdge.CreateNew(hDest);
        result := KEB;
showmessage('Create_KGF_EDGE - ok');
      except
      end;
end;
exports Create_KGF_EDGE;

function Delete_KGF_EDGE(aKEB: TKgfEdge): TKgfEdge; stdcall; export;
begin
      result := aKEB;
      try
        if assigned(aKEB) then exit;
        if aKEB.ClassName<>'TKgfEdge' then exit;
        aKEB.Free;
        result := nil;
      except
      end;
end;
exports Delete_KGF_EDGE;

function Navigate_KGF_EDGE(aKEB: TKgfEdge; aURL: string): boolean; stdcall; export;
begin
      result := false;
      try
        if assigned(aKEB) then exit;
        if aKEB.ClassName<>'TKgfEdge' then exit;
          if aURL='' then aURL := 'About:';

          aKEB.Ready := false;
          aKEB.Edge.UserDataFolder := TPath.Combine(TPath.GetDirectoryName(Application.ExeName), 'CustomCache');
          aKEB.Edge.Navigate(aURL);
          while not aKEB.Ready do {aKEB.Edge.} Application.ProcessMessages;

        result:= aKEB.IsSuccess;

      except
      end;
end;
exports Navigate_KGF_EDGE;

 
end.
