unit Test_KGF_Edge_Main;

interface

uses
  Winapi.Windows, Winapi.Messages, System.SysUtils, System.Variants, System.Classes, Vcl.Graphics,
  Vcl.Controls, Vcl.Forms, Vcl.Dialogs, Vcl.StdCtrls;

type
  TForm1 = class(TForm)
    Button1: TButton;
    Button2: TButton;
    Button3: TButton;
    Button4: TButton;
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure Button4Click(Sender: TObject);
    procedure Button1Click(Sender: TObject);
  private
    { Dclarations prives }
  public
    { Dclarations publiques }
  end;

TCreate_KGF_EDGE = function(hdest: HWND): TObject;
TNavigate_KGF_EDGE = function(aKEB: TObject; aURL: string): boolean;
TDelete_KGF_EDGE = function(aKEB: TObject): TObject;

var
  Form1: TForm1;
  hKGF_EDGE: THandle;
  Create_KGF_EDGE: TCreate_KGF_EDGE;
  Navigate_KGF_EDGE: TNavigate_KGF_EDGE;
  Delete_KGF_EDGE: TDelete_KGF_EDGE;
  KEB: TObject;

const
  dllnam = 'KGF_Edge.dll';

implementation

{$R *.dfm}

procedure TForm1.Button1Click(Sender: TObject);
begin
  if assigned(KEB) then begin
    showmessage('Edge is already loaded');
    exit;
  end;
  KEB := Create_KGF_EDGE(Form1.Handle);
end;

procedure TForm1.Button4Click(Sender: TObject);
begin
  if not assigned(KEB) then begin
    showmessage('Edge is not loaded');
    exit;
  end;
  KEB := Delete_KGF_EDGE(KEB);
end;

procedure TForm1.FormCreate(Sender: TObject);
begin
  hKGF_EDGE := LoadLibrary(dllnam);
  if hKGF_EDGE=0 then begin
    showmessage('Error: '+dllnam+' not found');
    exit;
  end;
  @Create_KGF_EDGE := GetProcAddress(hKGF_EDGE,'Create_KGF_EDGE');
  if @Create_KGF_Edge=nil then begin
    showmessage('Error: Create_KGF_EDGE not found in dll');
    exit;
  end;
  @Navigate_KGF_EDGE := GetProcAddress(hKGF_EDGE,'Navigate_KGF_EDGE');
  if @Navigate_KGF_EDGE=nil then begin
    showmessage('Error: Navigate_KGF_EDGE not found in dll');
    exit;
  end;
  @Delete_KGF_EDGE := GetProcAddress(hKGF_EDGE,'Delete_KGF_EDGE');
  if @Delete_KGF_EDGE=nil then begin
    showmessage('Error: Delete_KGF_EDGE not found in dll');
    exit;
  end;


  KEB := nil;
end;

procedure TForm1.FormDestroy(Sender: TObject);
begin
  if assigned(KEB) then KEB := Delete_KGF_Edge(KEB);
  if hKGF_Edge<>0 then FreeLibrary(hKGF_Edge);
end;


end.
